import * as _ from "lodash";
import { isObservableArray } from "mobx";

export class Helper {
	public static trimOrEmptyString(value: string | undefined): string {
		return typeof value === "string" ? value.trim() : "";
	}

	public static toStringToCompare(value: string | number | boolean | undefined | null): string {
		if (typeof value === "string") return value.trim();

		if (value === undefined || value === null) return "";

		return value.toString();
	}

	public static isArray<T = any>(value: T[] | any): value is T[] {
		return _.isArray(value) || isObservableArray(value);
	}
}
