import * as React from "react";
import { ActionProviderProps, createActionProvider } from "src/core/actionproviders/createActionProvider";
import { CourseActions } from "src/core/store/course";

export type DeleteCourseProps = ActionProviderProps<CourseActions.DeleteCourse> & {
	code: string;
};

export const {
	ActionProvider: DeleteCourse,
	ActionContextProvider: DeleteCourseContextProvider,
	ActionContextConsumer: DeleteCourseContextConsumer
} = createActionProvider<CourseActions.DeleteCourse, DeleteCourseProps>({
	onUnmount: () => {
		/**/
	},
	createAction: (component, rootStore) => new CourseActions.DeleteCourse(rootStore.courseStore),
	onPropsChange: (component, nextProps) => {
		const { action } = component;
		const { code } = nextProps;

		action.setCode(code);
	}
});
