import * as React from "react";
import { ActionProviderProps, createActionProvider } from "src/core/actionproviders/createActionProvider";
import { CourseActions } from "src/core/store/course";

export type FetchCoursesProps = ActionProviderProps<CourseActions.FetchCourses> & {
	autoFetch?: boolean;
};

export const {
	ActionProvider: FetchCourses,
	ActionContextProvider: FetchCoursesContextProvider,
	ActionContextConsumer: FetchCoursesContextConsumer
} = createActionProvider<CourseActions.FetchCourses, FetchCoursesProps>({
	onUnmount: () => {
		/**/
	},
	createAction: (component, rootStore) => {
		const { autoFetch } = component.props;
		const fetchCourses = new CourseActions.FetchCourses(rootStore.courseStore);

		if (autoFetch || (autoFetch === undefined && !fetchCourses.status.success)) fetchCourses.fetch();

		return fetchCourses;
	},
	onPropsChange: () => {
		/**/
	}
});
