import * as React from "react";
import { ActionProviderProps, createActionProvider } from "src/core/actionproviders/createActionProvider";
import { CourseActions } from "src/core/store/course";
import * as Models from "../../models";

export type FilterCoursesProps = ActionProviderProps<CourseActions.FilterCourses> & {
	courses: Models.Course[];
};

export const {
	ActionProvider: FilterCourses,
	ActionContextProvider: FilterCoursesContextProvider,
	ActionContextConsumer: FilterCoursesContextConsumer
} = createActionProvider<CourseActions.FilterCourses, FilterCoursesProps>({
	onUnmount: () => {
		/**/
	},
	createAction: (component, rootStore) => {
		const { courses } = component.props;
		const filterCourses = new CourseActions.FilterCourses(rootStore.courseStore);

		filterCourses.init(courses);

		return filterCourses;
	},
	onPropsChange: (component, nextProps) => {
		const { action } = component;
		action.init(nextProps.courses);
	}
});
