import * as React from "react";
import { ActionProviderProps, createActionProvider } from "src/core/actionproviders/createActionProvider";
import * as Models from "src/core/models";
import { CourseActions } from "src/core/store/course";

export type UpdateCourseProps = ActionProviderProps<CourseActions.UpdateCourse> & {
	course: Models.Course | undefined;
};

export const {
	ActionProvider: UpdateCourse,
	ActionContextProvider: UpdateCourseContextProvider,
	ActionContextConsumer: UpdateCourseContextConsumer
} = createActionProvider<CourseActions.UpdateCourse, UpdateCourseProps>({
	onUnmount: () => {
		/**/
	},
	createAction: (component, rootStore) => new CourseActions.UpdateCourse(rootStore.courseStore),
	onPropsChange: (component, nextProps) => {
		const { action } = component;
		const { course } = nextProps;

		action.setCourse(course);
	}
});
