import * as React from "react";
import { Models } from "src/core";
import { ActionProviderProps, createActionProvider } from "src/core/actionproviders/createActionProvider";
import { CourseClassActions } from "src/core/store/courseclass";

export type DeleteCourseClassProps = ActionProviderProps<CourseClassActions.DeleteCourseClass> & {
	courseClass: Models.CourseClass | number | undefined;
};

export const {
	ActionProvider: DeleteCourseClass,
	ActionContextProvider: DeleteCourseClassContextProvider,
	ActionContextConsumer: DeleteCourseClassContextConsumer
} = createActionProvider<CourseClassActions.DeleteCourseClass, DeleteCourseClassProps>({
	onUnmount: () => {
		/**/
	},
	createAction: (component, rootStore) => new CourseClassActions.DeleteCourseClass(rootStore.courseClassStore),
	onPropsChange: (component, nextProps) => {
		const { action } = component;
		const { courseClass } = nextProps;

		action.setCourseClass(courseClass);
	}
});
