import * as React from "react";
import { ActionProviderProps, createActionProvider } from "src/core/actionproviders/createActionProvider";
import { CourseClassActions } from "src/core/store/courseclass";

export type FetchLatestCourseClassesProps = ActionProviderProps<CourseClassActions.FetchLatestCourseClasses> & {
	autoFetch?: boolean;
};

export const {
	ActionProvider: FetchLatestCourseClasses,
	ActionContextProvider: FetchLatestCourseClassesContextProvider,
	ActionContextConsumer: FetchLatestCourseClassesContextConsumer
} = createActionProvider<CourseClassActions.FetchLatestCourseClasses, FetchLatestCourseClassesProps>({
	onUnmount: () => {
		/**/
	},
	createAction: (component, rootStore) => {
		const { autoFetch } = component.props;
		const action = new CourseClassActions.FetchLatestCourseClasses(rootStore.courseClassStore);

		if (autoFetch || (autoFetch === undefined && !action.status.success)) action.fetch();

		return action;
	},
	onPropsChange: () => {
		/**/
	}
});
