import * as React from "react";
import { Models } from "src/core";
import { ActionProviderProps, createActionProvider } from "src/core/actionproviders/createActionProvider";
import { CourseClassActions } from "src/core/store/courseclass";

export type UpdateCourseClassProps = ActionProviderProps<CourseClassActions.UpdateCourseClass> & {
	courseClass: Models.CourseClass | undefined;
};

export const {
	ActionProvider: UpdateCourseClass,
	ActionContextProvider: UpdateCourseClassContextProvider,
	ActionContextConsumer: UpdateCourseClassContextConsumer
} = createActionProvider<CourseClassActions.UpdateCourseClass, UpdateCourseClassProps>({
	onUnmount: () => {
		/**/
	},
	createAction: (component, rootStore) => new CourseClassActions.UpdateCourseClass(rootStore.courseClassStore),
	onPropsChange: (component, nextProps) => {
		const { action } = component;
		const { courseClass } = nextProps;

		action.setCourse(courseClass);
	}
});
