import * as React from "react";
import { ActionProviderProps, createActionProvider } from "src/core/actionproviders/createActionProvider";
import { FAQActions } from "src/core/store/faq";

export type FetchFAQsProps = ActionProviderProps<FAQActions.FetchFAQs> & {
	autoFetch?: boolean;
};

export const {
	ActionProvider: FetchFAQs,
	ActionContextProvider: FetchFAQsContextProvider,
	ActionContextConsumer: FetchFAQsContextConsumer
} = createActionProvider<FAQActions.FetchFAQs, FetchFAQsProps>({
	onUnmount: () => {
		/**/
	},
	createAction: (component, rootStore) => {
		const { autoFetch } = component.props;
		const fetchFAQs = new FAQActions.FetchFAQs(rootStore.faqStore);

		if (autoFetch || (autoFetch === undefined && !fetchFAQs.status.success)) fetchFAQs.fetch();

		return fetchFAQs;
	},
	onPropsChange: () => {
		/**/
	}
});
