import * as React from "react";
import { ActionProviderProps, createActionProvider } from "src/core/actionproviders/createActionProvider";
import * as Models from "src/core/models";
import { FAQActions } from "src/core/store/faq";

export type UpdateFAQProps = ActionProviderProps<FAQActions.UpdateFAQ> & {
	faq: Models.FAQ | undefined;
};

export const {
	ActionProvider: UpdateFAQ,
	ActionContextProvider: UpdateFAQContextProvider,
	ActionContextConsumer: UpdateFAQContextConsumer
} = createActionProvider<FAQActions.UpdateFAQ, UpdateFAQProps>({
	onUnmount: () => {
		/**/
	},
	createAction: (component, rootStore) => new FAQActions.UpdateFAQ(rootStore.faqStore),
	onPropsChange: (component, nextProps) => {
		const { action } = component;
		const { faq } = nextProps;

		action.setFAQ(faq);
	}
});
