export interface FormValidationError<TField, TValidationCode = FormValidationErrorValidationCode> {
	code: "FORM_VALIDATION_ERROR";
	field: TField;
	validationCode: TValidationCode;
	message: string;
}

export type FormValidationErrorValidationCode = "EMPTY_FIELD" | "INVALID_VALUE";

export const formValidationError = <TField, TValidationCode = FormValidationErrorValidationCode>(
	field: TField,
	validationCode: TValidationCode,
	message: string
): FormValidationError<TField, TValidationCode> => ({
	code: "FORM_VALIDATION_ERROR",
	field,
	validationCode,
	message
});
