import { observable } from "mobx";
import * as moment from "moment";
import { Base, CourseClass, User } from "./internal";

export type CourseSemester = 1 | 2;

export class Course extends Base {
	@observable
	public id: number;
	@observable
	public code: string;
	@observable
	public name: string | undefined;
	@observable
	public eva: string | undefined;
	@observable
	public semester: CourseSemester | undefined;
	@observable
	public year: number | undefined;
	@observable
	public classes: CourseClass[] | undefined;
	@observable
	public iconURL: string | undefined;

	@observable
	public createdAt: moment.Moment | undefined;
	@observable
	public createdBy: User | undefined;
	@observable
	public updatedAt: moment.Moment | undefined;
	@observable
	public updatedBy: User | undefined;
	@observable
	public deletedAt: moment.Moment | undefined;
	@observable
	public deletedBy: User | undefined;
}
