import { computed, observable } from "mobx";
import * as moment from "moment";
import { Base } from "./internal";

export enum UserRole {
	Admin = "admin",
	User = "user"
}

export class User extends Base {
	@observable
	public id: number;
	@observable
	public email: string | undefined;
	@observable
	public name: string | undefined;

	@observable
	public role: UserRole | undefined;

	@observable
	public createdAt: moment.Moment | undefined;
	@observable
	public updatedAt: moment.Moment | undefined;
	@observable
	public deletedAt: moment.Moment | undefined;

	@computed
	public get isAdmin() {
		return this.role === UserRole.Admin;
	}
}
