export enum CommonAppErrorCodes {
	Generic = "generic",
	UserNotSignedIn = "user_not_signed_in",
	NotEnoughPermissions = "not_enough_permissions",
	ObjectNotFound= "object_not_found",
}

export type AppError<T = CommonAppErrorCodes> = {
	code: T;
	message: string;
};

export const GenericError: AppError = {
	code: CommonAppErrorCodes.Generic,
	message: "Ha ocurrido un error"
};

export const UserNotSignedInError: AppError = {
	code: CommonAppErrorCodes.UserNotSignedIn,
	message: "Necesita estar logueado para hacer eso."
};
