import { configure } from "mobx";
import { CourseClassStore } from "src/core/store/courseclass/CourseClassStore";
import { FAQStore } from "src/core/store/faq/FAQStore";
import { CourseStore } from "./course/CourseStore";
import { UserStore } from "./user/UserStore";

configure({ enforceActions: "observed" });

export class RootStore {
	public static INSTANCE: RootStore;

	public courseClassStore = new CourseClassStore(this);
	public courseStore = new CourseStore(this);
	public faqStore = new FAQStore(this);
	public userStore = new UserStore(this);

	public reset() {
		this.courseClassStore = new CourseClassStore(this);
		this.courseStore = new CourseStore(this);
		this.faqStore = new FAQStore(this);
		this.userStore = new UserStore(this);
	}
}
